/* Generated by CIL v. 1.5.1 */
/* print_CIL_Input is false */

#line 16 "include/asm-generic/int-ll64.h"
typedef unsigned char u8;
#line 22 "include/asm-generic/int-ll64.h"
typedef unsigned int u32;
#line 157 "include/linux/types.h"
typedef unsigned int gfp_t;
#line 177 "include/linux/types.h"
struct __anonstruct_atomic_t_6 {
   int counter ;
};
#line 177 "include/linux/types.h"
typedef struct __anonstruct_atomic_t_6 atomic_t;
#line 183 "include/linux/types.h"
struct list_head {
   struct list_head *next ;
   struct list_head *prev ;
};
#line 20 "./arch/x86/include/asm/spinlock_types.h"
struct qspinlock {
   atomic_t val ;
};
#line 33 "include/asm-generic/qspinlock_types.h"
typedef struct qspinlock arch_spinlock_t;
#line 33 "include/linux/bottom_half.h"
struct lockdep_map;
#line 55 "include/linux/debug_locks.h"
struct stack_trace {
   unsigned int nr_entries ;
   unsigned int max_entries ;
   unsigned long *entries ;
   int skip ;
};
#line 28 "include/linux/stacktrace.h"
struct lockdep_subclass_key {
   char __one_byte ;
};
#line 53 "include/linux/lockdep.h"
struct lock_class_key {
   struct lockdep_subclass_key subkeys[8U] ;
};
#line 59 "include/linux/lockdep.h"
struct lock_class {
   struct list_head hash_entry ;
   struct list_head lock_entry ;
   struct lockdep_subclass_key *key ;
   unsigned int subclass ;
   unsigned int dep_gen_id ;
   unsigned long usage_mask ;
   struct stack_trace usage_traces[13U] ;
   struct list_head locks_after ;
   struct list_head locks_before ;
   unsigned int version ;
   unsigned long ops ;
   char const   *name ;
   int name_version ;
   unsigned long contention_point[4U] ;
   unsigned long contending_point[4U] ;
};
#line 144 "include/linux/lockdep.h"
struct lockdep_map {
   struct lock_class_key *key ;
   struct lock_class *class_cache[2U] ;
   char const   *name ;
   int cpu ;
   unsigned long ip ;
};
#line 546 "include/linux/lockdep.h"
struct raw_spinlock {
   arch_spinlock_t raw_lock ;
   unsigned int magic ;
   unsigned int owner_cpu ;
   void *owner ;
   struct lockdep_map dep_map ;
};
#line 33 "include/linux/spinlock_types.h"
struct __anonstruct____missing_field_name_35 {
   u8 __padding[24U] ;
   struct lockdep_map dep_map ;
};
#line 33 "include/linux/spinlock_types.h"
union __anonunion____missing_field_name_34 {
   struct raw_spinlock rlock ;
   struct __anonstruct____missing_field_name_35 __annonCompField17 ;
};
#line 33 "include/linux/spinlock_types.h"
struct spinlock {
   union __anonunion____missing_field_name_34 __annonCompField18 ;
};
#line 76 "include/linux/spinlock_types.h"
typedef struct spinlock spinlock_t;
#line 32 "include/linux/mm_types.h"
struct kmem_cache;
#line 532 "include/linux/input.h"
enum rc_type {
    RC_TYPE_UNKNOWN = 0,
    RC_TYPE_OTHER = 1,
    RC_TYPE_LIRC = 2,
    RC_TYPE_RC5 = 3,
    RC_TYPE_RC5X = 4,
    RC_TYPE_RC5_SZ = 5,
    RC_TYPE_JVC = 6,
    RC_TYPE_SONY12 = 7,
    RC_TYPE_SONY15 = 8,
    RC_TYPE_SONY20 = 9,
    RC_TYPE_NEC = 10,
    RC_TYPE_SANYO = 11,
    RC_TYPE_MCE_KBD = 12,
    RC_TYPE_RC6_0 = 13,
    RC_TYPE_RC6_6A_20 = 14,
    RC_TYPE_RC6_6A_24 = 15,
    RC_TYPE_RC6_6A_32 = 16,
    RC_TYPE_RC6_MCE = 17,
    RC_TYPE_SHARP = 18,
    RC_TYPE_XMP = 19
} ;
#line 555 "include/linux/input.h"
struct rc_map_table {
   u32 scancode ;
   u32 keycode ;
};
#line 83 "include/media/rc-map.h"
struct rc_map {
   struct rc_map_table *scan ;
   unsigned int size ;
   unsigned int len ;
   unsigned int alloc ;
   enum rc_type rc_type ;
   char const   *name ;
   spinlock_t lock ;
};
#line 93 "include/media/rc-map.h"
struct rc_map_list {
   struct list_head list ;
   struct rc_map map ;
};
#line 29 "include/linux/types.h"
typedef _Bool bool;
#line 361 "./arch/x86/include/asm/pgtable_types.h"
struct page;
#line 26 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
extern void *ldv_undef_ptr(void) ;
#line 293 "include/linux/slab.h"
void *ldv_kmem_cache_alloc_20(struct kmem_cache *ldv_func_arg1 , gfp_t flags ) ;
#line 18 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/dscv/ri/43_2a/drivers/media/rc/keymaps/rc-imon-pad.o.c.prepared"
void ldv_check_alloc_flags(gfp_t flags ) ;
#line 101 "include/media/rc-map.h"
extern int rc_map_register(struct rc_map_list * ) ;
#line 102
extern void rc_map_unregister(struct rc_map_list * ) ;
#line 22 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/dscv/ri/43_2a/drivers/media/rc/keymaps/rc-imon-pad.c"
static struct rc_map_table imon_pad[90U]  = 
#line 22 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/dscv/ri/43_2a/drivers/media/rc/keymaps/rc-imon-pad.c"
  {      {713135543U, 168U}, 
        {696456631U, 168U}, 
        {729879991U, 208U}, 
        {730011063U, 208U}, 
        {730928567U, 412U}, 
        {696358327U, 407U}, 
        {713102775U, 207U}, 
        {713233847U, 207U}, 
        {714151351U, 119U}, 
        {731321783U, 128U}, 
        {696325559U, 167U}, 
        {16809984U, 103U}, 
        {16809728U, 108U}, 
        {16777344U, 105U}, 
        {16777343U, 106U}, 
        {715462071U, 103U}, 
        {680859063U, 108U}, 
        {698684855U, 105U}, 
        {732239287U, 106U}, 
        {33554476U, 57U}, 
        {714282423U, 57U}, 
        {33554472U, 28U}, 
        {681678263U, 28U}, 
        {679581111U, 174U}, 
        {33554473U, 1U}, 
        {733418935U, 1U}, 
        {33554474U, 14U}, 
        {681645495U, 14U}, 
        {731223479U, 113U}, 
        {681809335U, 115U}, 
        {681940407U, 114U}, 
        {680760759U, 402U}, 
        {679974327U, 403U}, 
        {33554462U, 513U}, 
        {33554463U, 514U}, 
        {33554464U, 515U}, 
        {33554465U, 516U}, 
        {33554466U, 517U}, 
        {33554467U, 518U}, 
        {33554468U, 519U}, 
        {33554469U, 520U}, 
        {33554470U, 521U}, 
        {33554471U, 512U}, 
        {682988983U, 513U}, 
        {733058487U, 514U}, 
        {682726839U, 515U}, 
        {713397687U, 516U}, 
        {697669047U, 517U}, 
        {715494839U, 518U}, 
        {731092407U, 519U}, 
        {713364919U, 520U}, 
        {715199927U, 521U}, 
        {732272055U, 512U}, 
        {35651621U, 522U}, 
        {682956215U, 522U}, 
        {35651616U, 523U}, 
        {698422711U, 523U}, 
        {730142135U, 393U}, 
        {697406903U, 392U}, 
        {731977143U, 442U}, 
        {681907639U, 377U}, 
        {698586551U, 389U}, 
        {698521015U, 389U}, 
        {732136887U, 139U}, 
        {732140983U, 139U}, 
        {679810487U, 156U}, 
        {716641719U, 212U}, 
        {696620471U, 370U}, 
        {730174903U, 368U}, 
        {698717623U, 372U}, 
        {715363767U, 375U}, 
        {697374135U, 374U}, 
        {697382327U, 374U}, 
        {16842752U, 272U}, 
        {16908288U, 273U}, 
        {16842880U, 272U}, 
        {16908416U, 273U}, 
        {1753416119U, 272U}, 
        {1753514423U, 273U}, 
        {714315191U, 154U}, 
        {730043831U, 359U}, 
        {680596919U, 116U}, 
        {699504055U, 161U}, 
        {697537975U, 162U}, 
        {41943040U, 438U}, 
        {729912759U, 438U}, 
        {33554533U, 127U}, 
        {683087287U, 127U}, 
        {716281271U, 226U}, 
        {699864503U, 204U}};
#line 134 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/dscv/ri/43_2a/drivers/media/rc/keymaps/rc-imon-pad.c"
static struct rc_map_list imon_pad_map  =    {{0, 0}, {(struct rc_map_table *)(& imon_pad), 90U, 0U, 0U, 1, "rc-imon-pad", {{{{{0}},
                                                                                    0U,
                                                                                    0U,
                                                                                    0,
                                                                                    {0,
                                                                                     {0,
                                                                                      0},
                                                                                     0,
                                                                                     0,
                                                                                     0UL}}}}}};
#line 144 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/dscv/ri/43_2a/drivers/media/rc/keymaps/rc-imon-pad.c"
static int init_rc_map_imon_pad(void) 
{ 
  int tmp ;

  {
#line 146
  tmp = rc_map_register(& imon_pad_map);
#line 146
  return (tmp);
}
}
#line 149 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/dscv/ri/43_2a/drivers/media/rc/keymaps/rc-imon-pad.c"
static void exit_rc_map_imon_pad(void) 
{ 


  {
#line 151
  rc_map_unregister(& imon_pad_map);
#line 152
  return;
}
}
#line 176
extern void ldv_check_final_state(void) ;
#line 185
extern void ldv_initialize(void) ;
#line 188
extern void ldv_handler_precall(void) ;
#line 191
extern int nondet_int(void) ;
#line 194 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/dscv/ri/43_2a/drivers/media/rc/keymaps/rc-imon-pad.c"
int LDV_IN_INTERRUPT  ;
#line 197 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/dscv/ri/43_2a/drivers/media/rc/keymaps/rc-imon-pad.c"
void main(void) 
{ 
  int tmp ;
  int tmp___0 ;
  int tmp___1 ;

  {
#line 209
  LDV_IN_INTERRUPT = 1;
#line 218
  ldv_initialize();
#line 224
  ldv_handler_precall();
#line 225
  tmp = init_rc_map_imon_pad();
#line 225
  if (tmp != 0) {
#line 226
    goto ldv_final;
  } else {

  }
#line 228
  goto ldv_25641;
  ldv_25640: 
#line 231
  tmp___0 = nondet_int();
#line 231
  switch (tmp___0) {
  default: ;
#line 233
  goto ldv_25639;
  }
  ldv_25639: ;
  ldv_25641: 
#line 228
  tmp___1 = nondet_int();
#line 228
  if (tmp___1 != 0) {
#line 230
    goto ldv_25640;
  } else {

  }

#line 245
  ldv_handler_precall();
#line 246
  exit_rc_map_imon_pad();
  ldv_final: 
#line 249
  ldv_check_final_state();
#line 252
  return;
}
}
#line 171 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/dscv/ri/43_2a/drivers/media/rc/keymaps/rc-imon-pad.o.c.prepared"
void *ldv_kmem_cache_alloc_20(struct kmem_cache *ldv_func_arg1 , gfp_t flags ) 
{ 
  void *tmp ;

  {
#line 174
  ldv_check_alloc_flags(flags);
#line 175
  tmp = ldv_undef_ptr();
#line 175
  return (tmp);
}
}
#line 10 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static void ldv_error(void) 
{ 


  {
  ERROR: ;
#line 12
  goto ERROR;
}
}
#line 25
extern int ldv_undef_int(void) ;
#line 7 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
bool ldv_is_err(void const   *ptr ) 
{ 


  {
#line 10
  return ((unsigned long )ptr > 2012UL);
}
}
#line 14 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
void *ldv_err_ptr(long error ) 
{ 


  {
#line 17
  return ((void *)(2012L - error));
}
}
#line 21 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
long ldv_ptr_err(void const   *ptr ) 
{ 


  {
#line 24
  return ((long )(2012UL - (unsigned long )ptr));
}
}
#line 28 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
bool ldv_is_err_or_null(void const   *ptr ) 
{ 
  bool tmp ;
  int tmp___0 ;

  {
#line 31
  if ((unsigned long )ptr == (unsigned long )((void const   *)0)) {
#line 31
    tmp___0 = 1;
  } else {
#line 31
    tmp = ldv_is_err(ptr);
#line 31
    if ((int )tmp) {
#line 31
      tmp___0 = 1;
    } else {
#line 31
      tmp___0 = 0;
    }
  }
#line 31
  return ((bool )tmp___0);
}
}
#line 20 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/rule-instrumentor/43_2a/common-model/ldv_common_model.c"
int ldv_spin  =    0;
#line 24 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/rule-instrumentor/43_2a/common-model/ldv_common_model.c"
void ldv_check_alloc_flags(gfp_t flags ) 
{ 


  {
#line 27
  if (ldv_spin != 0 && (flags & 16U) != 0U) {
#line 27
    ldv_error();
  } else {

  }
#line 31
  return;
}
}
#line 30
extern struct page *ldv_some_page(void) ;
#line 33 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/rule-instrumentor/43_2a/common-model/ldv_common_model.c"
struct page *ldv_check_alloc_flags_and_return_some_page(gfp_t flags ) 
{ 
  struct page *tmp ;

  {
#line 36
  if (ldv_spin != 0 && (flags & 16U) != 0U) {
#line 36
    ldv_error();
  } else {

  }
#line 38
  tmp = ldv_some_page();
#line 38
  return (tmp);
}
}
#line 42 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/rule-instrumentor/43_2a/common-model/ldv_common_model.c"
void ldv_check_alloc_nonatomic(void) 
{ 


  {
#line 45
  if (ldv_spin != 0) {
#line 45
    ldv_error();
  } else {

  }
#line 49
  return;
}
}
#line 49 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/rule-instrumentor/43_2a/common-model/ldv_common_model.c"
void ldv_spin_lock(void) 
{ 


  {
#line 52
  ldv_spin = 1;
#line 53
  return;
}
}
#line 56 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/rule-instrumentor/43_2a/common-model/ldv_common_model.c"
void ldv_spin_unlock(void) 
{ 


  {
#line 59
  ldv_spin = 0;
#line 60
  return;
}
}
#line 63 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/3793/dscv_tempdir/rule-instrumentor/43_2a/common-model/ldv_common_model.c"
int ldv_spin_trylock(void) 
{ 
  int is_lock ;

  {
#line 68
  is_lock = ldv_undef_int();
#line 70
  if (is_lock != 0) {
#line 73
    return (0);
  } else {
#line 78
    ldv_spin = 1;
#line 80
    return (1);
  }
}
}
